#define VERSION "0084"

//#include "RobboLito.h"

#define uint8 unsigned char
#define sint8 signed char
#define sint16 signed short int
#define uint16 unsigned short int
#define uint64 unsigned long long int
#define sint64 long long int
#define sint32 int
#define uint32 unsigned int

#define logico uint8
#define VERO 1
#define FALSO 0

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "sorvegliare.h"

logico bordo_legittimo;

void
opzione (char *string)
{
  char *v;
  int valu;
  if (!memcmp (string, "TranspositionalTabularSizing", 28))
    {
      v = strstr (string, "value");
      if (v)
	{
	  valu = atoi (v + 6);
	  valu = inizializzazione_zobrist (valu);
	  TRASMISSIONE ("Optional TranspositionalTabularSizing %d\n", valu);
	}
    }
}

void
uci ()
{
  TRASMISSIONE ("id name RobboLito version %s\n", VERSION);
  TRASMISSIONE ("id author Yakov Petrovich Golyadkin, ");
  TRASMISSIONE ("Igor Igorovoich Igoronov, Roberto Pescatore\n");
  TRASMISSIONE ("id copyright Yakov Petrovich Golyadkin (all), "
		"92th year from Revolution, PUBLICDOMAIN (workers)\n");
  TRASMISSIONE ("id dedication To Vladimir Ilyich\n");
  TRASMISSIONE
    ("option name TranspositionalTabularSizing (Zobrist) in MegaBytes.");
  TRASMISSIONE (" Note: Only dyadic powers suffice terminally! ");
  TRASMISSIONE ("type spin min 1 max 16384 default 32\n");
  TRASMISSIONE ("uciok\n");
}

void
readyok ()
{
  TRASMISSIONE ("readyok\n");
}

static void quit ()
{
  exit (0);
}

static void ingresso_analizi (char *IN)
{
  if (!strcmp (IN, "quit"))
    quit ();
  if (!strcmp (IN, "stop"))
    cerca_alt (0);
  if (!strcmp (IN, "isready"))
    readyok ();
  if (!strcmp (IN, "ucinewgame"))
    {
      cerca_alt (0);
      partita_nuova (VERO);
    }
  if (salto_ok)
    return;
  if (!memcmp (IN, "go", 2))
    {
      cerca_inizializzazione (IN);
      if (bordo_legittimo)
	cerca ();
    }
  if (!memcmp (IN, "position", 8))
    posizionale_inizializzazione (IN + 9);
  if (!memcmp (IN, "setoption name", 14))
    opzione (IN + 15);
  if (!strcmp (IN, "uci"))
    uci ();
}

void
ingresso ()
{
  char IN[65536];
  fgets (IN, 65536, stdin);
  IN[strlen (IN) - 1] = 0;
  ingresso_analizi (IN);
}
